Zum Hauptinhalt springen

Integration mit Vue

Tipp

Dieser Leitfaden setzt Kenntnisse der grundlegenden Konzepte und Muster von Vue voraus. Als Hintergrundlektüre empfiehlt sich die Vue 3-Dokumentation.

DHTMLX Kanban ist mit Vue kompatibel. Das vollständige Codebeispiel für Vue 3 ist auf GitHub verfügbar.

Projekt erstellen

Info

Installieren Sie Node.js vor der Erstellung des Projekts.

Mit folgendem Befehl wird ein neues Vue-Projekt erstellt:

npm create vue@latest

Der Befehl führt create-vue aus, das offizielle Vue-Projekt-Scaffolding-Tool. Details finden Sie im Vue.js Quick Start.

Nennen Sie das Projekt my-vue-kanban-app.

Installation der Abhängigkeiten

Wechseln Sie in das App-Verzeichnis:

cd my-vue-kanban-app

Installieren Sie die Abhängigkeiten und starten Sie den Dev-Server mit einem der folgenden Paketmanager:

yarn
yarn start // oder yarn dev
npm install
npm run dev

Die App läuft unter einer localhost-Adresse (zum Beispiel http://localhost:3000).

Kanban erstellen

Stoppen Sie den Dev-Server und installieren Sie das Kanban-Paket.

Schritt 1. Paket installieren

Laden Sie das Test-Kanban-Paket herunter und folgen Sie den Schritten in der README-Datei. Die Testversion ist 30 Tage lang verfügbar.

Schritt 2. Komponente erstellen

Erstellen Sie eine Vue-Komponente, die Kanban und die Toolbar einbindet. Fügen Sie eine neue Datei Kanban.vue im Verzeichnis src/components/ hinzu.

Quellcode importieren

Öffnen Sie Kanban.vue und importieren Sie die Kanban-Quellcodes. Die Import-Pfade hängen von der Paketversion ab:

  • Für die PRO-Version, die aus einem lokalen Ordner installiert wird:
Kanban.vue
<script>
import { Kanban, Toolbar } from 'dhx-kanban-package';
import 'dhx-kanban-package/dist/kanban.css';
</script>

Wenn das Paket minifizierte Quellcodes enthält, importieren Sie die CSS-Datei als kanban.min.css.

  • Für die Testversion:
Kanban.vue
<script>
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import '@dhx/trial-kanban/dist/kanban.css';
</script>

Dieses Tutorial verwendet die Testversion von Kanban.

Container einrichten und Kanban initialisieren

Um Kanban mit der Toolbar anzuzeigen, erstellen Sie zwei Container und rufen Sie die Konstruktoren auf. Der folgende Code-Ausschnitt verbindet Refs und instanziiert die Komponenten innerhalb von mounted():

Kanban.vue
<script>
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export default {
mounted() {
// Initialisierung der Kanban-Komponente
this.kanban = new Kanban(this.$refs.kanban_container, {});

// Initialisierung der Toolbar-Komponente
this.toolbar = new Toolbar(this.$refs.toolbar_container, {
api: this.kanban.api, // Kanban-internes API bereitstellen
// weitere Konfigurationseigenschaften
});
},

unmounted() {
this.kanban.destructor(); // Kanban zerstören
this.toolbar.destructor(); // Toolbar zerstören
}
};
</script>

<template>
<div class="component_container">
<div ref="toolbar_container"></div>
<div ref="kanban_container" class="widget"></div>
</div>
</template>

Styles hinzufügen

Fügen Sie Styles für Kanban und den Container in der Haupt-CSS-Datei hinzu:

main.css
/* specify styles for initial page */
html,
body,
#app { /* make sure that you use the #app root container */
height: 100%;
padding: 0;
margin: 0;
}

/* specify styles for Kanban and Toolbar container */
.component_container {
height: 100%;
margin: 0 auto;
}

/* specify styles for Kanban container */
.widget {
height: calc(100% - 56px);
}

Daten laden

Um Kanban mit Daten zu befüllen, stellen Sie einen Datensatz bereit. Erstellen Sie die Datei data.js im Verzeichnis src/:

data.js
export function getData() {
const columns = [
{
label: "Backlog",
id: "backlog"
},
{
label: "In progress",
id: "inprogress"
},
// ...
];

const cards = [
{
id: 1,
label: "Integration with Angular/React",
priority: 1,
color: "#65D3B3",
start_date: new Date("01/07/2021"),
users: [3, 2],
column: "backlog",
type: "feature",
},
{
label: "Archive the cards/boards",
priority: 3,
color: "#58C3FE",
users: [4],
progress: 1,
column: "backlog",
type: "feature",
},
// ...
];

const rows = [
{
label: "Feature",
id: "feature",
},
{
label: "Task",
id: "task",
}
];

return { columns, cards, rows };
}

Öffnen Sie App.vue und importieren Sie den Datensatz. Initialisieren Sie die Werte über die interne Methode data() und übergeben Sie sie als Props an die neue <Kanban/>-Komponente:

App.vue
<script>
import Kanban from "./components/Kanban.vue";
import { getData } from "./data";

export default {
components: { Kanban },
data() {
const { columns, cards, rows } = getData();
return {
columns,
cards,
rows
};
}
};
</script>

<template>
<Kanban :columns="columns" :cards="cards" :rows="rows"/>
</template>

Öffnen Sie Kanban.vue und wenden Sie die Props auf das Kanban-Konfigurationsobjekt an:

Kanban.vue
<script>
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export default {
props: ["cards", "columns", "rows"],

mounted() {
this.kanban = new Kanban(this.$refs.kanban_container, {
cards: this.cards,
columns: this.columns,
rows: this.rows,
rowKey: "type",
// weitere Konfigurationseigenschaften
});

this.toolbar = new Toolbar(this.$refs.toolbar_container, {
api: this.kanban.api,
// weitere Konfigurationseigenschaften
});
},

unmounted() {
this.kanban.destructor();
this.toolbar.destructor();
}
};
</script>

<template>
<div class="component_container">
<div ref="toolbar_container"></div>
<div ref="kanban_container" class="widget"></div>
</div>
</template>

Alternativ können Sie Daten nach der Erstellung der Instanz mit setConfig() oder parse() innerhalb von mounted() laden:

Kanban.vue
<script>
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export default {
props: ["cards", "columns", "rows"],

mounted() {
this.kanban = new Kanban(this.$refs.kanban_container, {
columns: [],
cards: [],
rows: [],
rowKey: "type",
// weitere Konfigurationseigenschaften
});

this.toolbar = new Toolbar(this.$refs.toolbar_container, {
api: this.kanban.api,
// weitere Konfigurationseigenschaften
});

this.kanban.setConfig({
cards: this.cards,
columns: this.columns,
rows: this.rows
});

},

unmounted() {
this.kanban.destructor();
this.toolbar.destructor();
}
};
</script>

<template>
<div class="component_container">
<div ref="toolbar_container"></div>
<div ref="kanban_container" class="widget"></div>
</div>
</template>

Die Kanban-Komponente ist nun einsatzbereit. Sobald das Element gerendert wird, initialisiert sich Kanban mit den Daten. Die vollständige Liste der unterstützten Konfigurationseigenschaften finden Sie in der Kanban API-Referenz.

Ereignisse verarbeiten

Benutzeraktionen in Kanban lösen Ereignisse aus. Lauschen Sie auf Ereignisse, um auf bestimmte Aktionen zu reagieren. Die vollständige Liste finden Sie in der Kanban-Ereignisreferenz.

Öffnen Sie Kanban.vue und erweitern Sie die Methode mounted():

Kanban.vue
<script>
// ...
export default {
// ...
mounted() {
this.kanban = new Kanban(this.$refs.kanban_container, {});

this.kanban.api.on("add-card", (obj) => {
console.log(obj.columnId);
});
},

unmounted() {
this.kanban.destructor();
}
}
</script>

// ...

Starten Sie die App, um das befüllte Kanban-Board auf der Seite anzuzeigen.

DHTMLX Kanban-Board, das in einer Vue-Anwendung initialisiert wurde, mit gefüllten Spalten und Karten

Das vollständige Projekt finden Sie auf GitHub.

Zum Hauptinhalt springen

Integration mit Angular

Tipp

Dieser Leitfaden setzt Kenntnisse der Angular-Konzepte und -Muster voraus. Als Hintergrund empfiehlt sich die Angular-Dokumentation.

DHTMLX Kanban ist mit Angular kompatibel. Das vollständige Codebeispiel ist auf GitHub verfügbar.

Projekt erstellen

Info

Installieren Sie Angular CLI und Node.js, bevor Sie das Projekt anlegen.

Der folgende Befehl erstellt ein neues Projekt my-angular-kanban-app mit Angular CLI:

ng new my-angular-kanban-app
Hinweis

Deaktivieren Sie Server-Side Rendering (SSR) und Static Site Generation (SSG/Prerendering) auf Nachfrage, damit das Projekt mit dieser Anleitung übereinstimmt.

Der Befehl installiert alle notwendigen Tools. Weitere Schritte sind nicht erforderlich.

Abhängigkeiten installieren

Wechseln Sie in das neu erstellte App-Verzeichnis:

cd my-angular-kanban-app

Installieren Sie die Abhängigkeiten und starten Sie den Entwicklungsserver mit dem yarn Paketmanager:

yarn
yarn start

Die App läuft unter einer lokalen Adresse (zum Beispiel http://localhost:3000).

Kanban erstellen

Stoppen Sie den Entwicklungsserver und installieren Sie das Kanban-Paket.

Schritt 1. Paket installieren

Laden Sie das Trial-Kanban-Paket herunter und folgen Sie den Schritten in der README-Datei. Die Trial-Version ist 30 Tage verfügbar.

Schritt 2. Komponente erstellen

Erstellen Sie eine Angular-Komponente, die Kanban und die Toolbar einbindet. Erstellen Sie den Ordner src/app/kanban/ und fügen Sie darin eine Datei kanban.component.ts hinzu.

Quellcodedateien importieren

Öffnen Sie kanban.component.ts und importieren Sie die Kanban-Quelldateien. Der Importpfad hängt von der Paketversion ab:

  • Für die PRO-Version, die aus einem lokalen Ordner installiert wird:
import { Kanban, Toolbar } from 'dhx-kanban-package';
  • Für die Trial-Version:
import { Kanban, Toolbar } from '@dhx/trial-kanban';

Dieses Tutorial verwendet die Trial-Version von Kanban.

Container einrichten und Kanban initialisieren

Um Kanban mit der Toolbar anzuzeigen, richten Sie zwei Container ein und rufen Sie die Konstruktoren auf. Der folgende Code definiert das Komponenten-Template, referenziert die Container und erstellt die Instanzen:

kanban.component.ts
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation} from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "kanban", // ein Template-Name, der in "app.component.ts" als <kanban /> verwendet wird
styleUrls: ["./kanban.component.css"], // CSS einbinden
template: `<div class = "component_container">
<div #toolbar_container></div>
<div #kanban_container class = "widget"></div>
</div>`
})

export class KanbanComponent implements OnInit, OnDestroy {
// Container für Toolbar initialisieren
@ViewChild("toolbar_container", { static: true }) toolbar_container!: ElementRef;
// Container für Kanban initialisieren
@ViewChild("kanban_container", { static: true }) kanban_container!: ElementRef;

private _kanban!: Kanban;
private _toolbar!: Toolbar;

ngOnInit() {
// Kanban-Komponente initialisieren
this._kanban = new Kanban(this.kanban_container.nativeElement, {});

// Toolbar-Komponente initialisieren
this._toolbar = new Toolbar(this.toolbar_container.nativeElement, {
api: this._kanban.api,
// weitere Konfigurationseigenschaften
});
}

ngOnDestroy(): void {
this._kanban.destructor(); // Kanban zerstören
this._toolbar.destructor(); // Toolbar zerstören
}
}

Styles hinzufügen

Fügen Sie Styles für Kanban und den Container hinzu. Erstellen Sie die Datei kanban.component.css im Verzeichnis src/app/kanban/:

kanban.component.css
/* Kanban-Styles importieren */
@import "@dhx/trial-kanban/dist/kanban.css";

/* Styles für die Startseite */
html,
body{
height: 100%;
padding: 0;
margin: 0;
}

/* Styles für Kanban- und Toolbar-Container */
.component_container {
height: 100%;
margin: 0 auto;
}

/* Styles für Kanban-Container */
.widget {
height: calc(100% - 56px);
}

Daten laden

Um Kanban mit Daten zu befüllen, stellen Sie einen Datensatz bereit. Erstellen Sie die Datei data.ts im Verzeichnis src/app/kanban/:

data.ts
export function getData() {
const columns = [
{
label: "Backlog",
id: "backlog"
},
{
label: "In progress",
id: "inprogress"
},
// ...
];

const cards = [
{
id: 1,
label: "Integration with Angular/React",
priority: 1,
color: "#65D3B3",
start_date: new Date("01/07/2021"),
users: [3, 2],
column: "backlog",
type: "feature",
},
{
label: "Archive the cards/boards ",
priority: 3,
color: "#58C3FE",
users: [4],
progress: 1,
column: "backlog",
type: "feature",
},
// ...
];

const rows = [
{
label: "Feature",
id: "feature",
},
{
label: "Task",
id: "task",
}
];

return { columns, cards, rows };
}

Öffnen Sie kanban.component.ts, importieren Sie den Datensatz und übergeben Sie die Dateneigenschaften an das Kanban-Konfigurationsobjekt innerhalb von ngOnInit():

kanban.component.ts
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import { getData } from "./data"; // Daten importieren
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation} from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "kanban",
styleUrls: ["./kanban.component.css"],
template: `<div class = "component_container">
<div #toolbar_container></div>
<div #kanban_container class = "widget"></div>
</div>`
})

export class KanbanComponent implements OnInit, OnDestroy {
@ViewChild("toolbar_container", { static: true }) toolbar_container!: ElementRef;
@ViewChild("kanban_container", { static: true }) kanban_container!: ElementRef;

private _kanban!: Kanban;
private _toolbar!: Toolbar;

ngOnInit() {
const { cards, columns, rows } = getData(); // Daten initialisieren
this._kanban = new Kanban(this.kanban_container.nativeElement, {
columns, // Spaltendaten anwenden
cards, // Kartendaten anwenden
rows, // Zeilendaten anwenden
rowKey: "type",
// weitere Konfigurationseigenschaften
});

this._toolbar = new Toolbar(this.toolbar_container.nativeElement, {
api: this._kanban.api,
// weitere Konfigurationseigenschaften
});
}

ngOnDestroy(): void {
this._kanban.destructor();
this._toolbar.destructor();
}
}

Alternativ können Sie die Daten nach der Instanzerstellung mit setConfig() oder parse() innerhalb von ngOnInit() laden:

kanban.component.ts
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import { getData } from "./data"; // Daten importieren
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation} from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "kanban",
styleUrls: ["./kanban.component.css"],
template: `<div class = "component_container">
<div #toolbar_container></div>
<div #kanban_container class = "widget"></div>
</div>`
})

export class KanbanComponent implements OnInit, OnDestroy {
@ViewChild("toolbar_container", { static: true }) toolbar_container!: ElementRef;
@ViewChild("kanban_container", { static: true }) kanban_container!: ElementRef;

private _kanban!: Kanban;
private _toolbar!: Toolbar;

ngOnInit() {
const { cards, columns, rows } = getData(); // Daten initialisieren
this._kanban = new Kanban(this.kanban_container.nativeElement, {
columns: [],
cards: [],
rows: [],
rowKey: "type",
// weitere Konfigurationseigenschaften
});

this._toolbar = new Toolbar(this.toolbar_container.nativeElement, {
api: this._kanban.api,
// weitere Konfigurationseigenschaften
});

// Daten über die setConfig()- oder parse()-Methode anwenden
this._kanban.setConfig({
columns,
cards,
rows
});
}

ngOnDestroy(): void {
this._kanban.destructor();
this._toolbar.destructor();
}
}

Die Kanban-Komponente ist jetzt einsatzbereit. Wenn das Element gerendert wird, initialisiert sich Kanban mit den Daten. Die vollständige Liste der unterstützten Konfigurationseigenschaften finden Sie in der Kanban API-Referenz.

Ereignisse behandeln

Benutzeraktionen in Kanban lösen Ereignisse aus. Verwenden Sie Event-Listener, um auf bestimmte Aktionen zu reagieren. Die vollständige Liste finden Sie in der Kanban-Ereignisreferenz.

Öffnen Sie kanban.component.ts und erweitern Sie die Methode ngOnInit():

kanban.component.ts
// ...
ngOnInit() {
this._kanban = new Kanban(this.kanban_container.nativeElement, {});

this._kanban.api.on("add-card", (obj) => {
console.log(obj.columnId);
});
}

ngOnDestroy(): void {
this._kanban.destructor();
}

Schritt 3. Kanban zur App hinzufügen

Um die KanbanComponent in der App zu registrieren, öffnen Sie src/app/app.component.ts und ersetzen Sie den Standardcode:

app.component.ts
import { Component } from "@angular/core";

@Component({
selector: "app-root",
template: `<kanban/>`
})
export class AppComponent {
name = "";
}

Erstellen Sie app.module.ts im Verzeichnis src/app/ und deklarieren Sie die KanbanComponent:

app.module.ts
import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";

import { AppComponent } from "./app.component";
import { KanbanComponent } from "./kanban/kanban.component";

@NgModule({
declarations: [AppComponent, KanbanComponent],
imports: [BrowserModule],
bootstrap: [AppComponent]
})
export class AppModule {}

Öffnen Sie src/main.ts und ersetzen Sie den vorhandenen Code:

main.ts
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { AppModule } from "./app/app.module";
platformBrowserDynamic()
.bootstrapModule(AppModule)
.catch((err) => console.error(err));

Starten Sie die App, um das befüllte Kanban-Board auf der Seite anzuzeigen.

DHTMLX Kanban-Board, das in einer Angular-Anwendung initialisiert wurde, mit gefüllten Spalten und Karten

Das vollständige Projekt finden Sie auf GitHub.

Zum Hauptinhalt springen

Integration mit React

Tipp

Dieser Leitfaden setzt Kenntnisse der grundlegenden Konzepte und Muster von React voraus. Zur Auffrischung lesen Sie bitte die React Dokumentation.

DHTMLX Kanban ist mit React kompatibel. Das vollständige Codebeispiel ist auf GitHub verfügbar.

Ein Projekt erstellen

Info

Installieren Sie vor dem Erstellen eines neuen Projekts Vite (optional) und Node.js.

Erstellen Sie ein Standard-React-Projekt (oder React mit Vite). Nennen Sie das Projekt my-react-kanban-app:

npx create-react-app my-react-kanban-app

Abhängigkeiten installieren

Wechseln Sie in das neu erstellte App-Verzeichnis:

cd my-react-kanban-app

Installieren Sie die Abhängigkeiten und starten Sie den Entwicklungsserver mit einem der folgenden Paketmanager:

yarn
yarn start
npm install
npm run dev

Die App läuft unter einer lokalen Adresse (z.B. http://localhost:3000).

Kanban erstellen

Beenden Sie den Entwicklungsserver und installieren Sie das Kanban-Paket.

Schritt 1. Paket installieren

Laden Sie das Trial-Kanban-Paket herunter und befolgen Sie die Schritte in der README-Datei. Die Testversion ist 30 Tage verfügbar.

Schritt 2. Komponente erstellen

Erstellen Sie eine React-Komponente, die Kanban zur Anwendung hinzufügt. Legen Sie eine neue Datei im Verzeichnis src/ an und nennen Sie sie Kanban.jsx.

Quelldateien importieren

Öffnen Sie Kanban.jsx und importieren Sie die Kanban-Quelldateien. Die Importpfade hängen von der Paketversion ab:

  • Für die PRO-Version, die aus einem lokalen Ordner installiert wurde:
Kanban.jsx
import { Kanban, Toolbar } from 'dhx-kanban-package';
import 'dhx-kanban-package/dist/kanban.css';

Wenn das Paket minifizierte Quelldateien enthält, importieren Sie die CSS-Datei als kanban.min.css.

  • Für die Testversion:
Kanban.jsx
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import "@dhx/trial-kanban/dist/kanban.css";

Dieses Tutorial verwendet die Testversion von Kanban.

Container einrichten und Kanban initialisieren

Um Kanban mit der Toolbar anzuzeigen, erstellen Sie zwei Container und rufen Sie die Konstruktoren auf. Der folgende Code-Ausschnitt verbindet Refs und instanziiert die Komponenten innerhalb von useEffect():

Kanban.jsx
import { useEffect, useRef } from "react";
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import '@dhx/trial-kanban/dist/kanban.css'; // Kanban-Stile einbinden

export default function KanbanComponent(props) {
let toolbar_container = useRef(); // Container für Toolbar initialisieren
let kanban_container = useRef(); // Container für Kanban initialisieren

useEffect(() => {
// Kanban-Komponente initialisieren
const kanban = new Kanban(kanban_container.current, {});

// Toolbar-Komponente initialisieren
const toolbar = new Toolbar(toolbar_container.current, {
api: kanban.api, // Kanban-internes API bereitstellen
// weitere Konfigurationseigenschaften
});

return () => {
kanban.destructor(); // Kanban zerstören
toolbar.destructor(); // Toolbar zerstören
};
}, []);

return <div className="component_container">
<div ref={toolbar_container}></div>
<div ref={kanban_container} className="widget"></div>
</div>
}

Stile hinzufügen

Fügen Sie die Stile für Kanban und den Container in der Haupt-CSS-Datei hinzu:

index.css
/* specify styles for initial page */
html,
body,
#root {
height: 100%;
padding: 0;
margin: 0;
}

/* specify styles for Kanban and Toolbar container */
.component_container {
height: 100%;
margin: 0 auto;
}

/* specify styles for Kanban container */
.widget {
height: calc(100% - 56px);
}

Daten laden

Um Kanban mit Daten zu befüllen, stellen Sie einen Datensatz bereit. Erstellen Sie die Datei data.js im Verzeichnis src/:

data.js
export function getData() {
const columns = [
{
label: "Backlog",
id: "backlog"
},
{
label: "In progress",
id: "inprogress"
},
// ...
];

const cards = [
{
id: 1,
label: "Integration with Angular/React",
priority: 1,
color: "#65D3B3",
start_date: new Date("01/07/2021"),
users: [3, 2],
column: "backlog",
type: "feature",
},
{
label: "Archive the cards/boards ",
priority: 3,
color: "#58C3FE",
users: [4],
progress: 1,
column: "backlog",
type: "feature",
},
// ...
];

const rows = [
{
label: "Feature",
id: "feature",
},
{
label: "Task",
id: "task",
}
];

return { columns, cards, rows };
}

Öffnen Sie App.js, importieren Sie den Datensatz und übergeben Sie die Werte per props an die neue <Kanban/>-Komponente:

App.js
import Kanban from "./Kanban";
import { getData } from "./data";

function App() {
const { columns, cards, rows } = getData();
return <Kanban columns={columns} cards={cards} rows={rows} />;
}

export default App;

Öffnen Sie Kanban.jsx und wenden Sie die props auf das Kanban-Konfigurationsobjekt an:

Kanban.jsx
import { useEffect, useRef } from "react";
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export default function KanbanComponent(props) {
let kanban_container = useRef();
let toolbar_container = useRef();

useEffect(() => {
const kanban = new Kanban(kanban_container.current, {
columns: props.columns, // Spalten-Daten anwenden
cards: props.cards, // Karten-Daten anwenden
rows: props.rows, // Zeilen-Daten anwenden
rowKey: "type",
// weitere Konfigurationseigenschaften
});

const toolbar = new Toolbar(toolbar_container.current, {
api: kanban.api,
// weitere Konfigurationseigenschaften
});

return () => {
kanban.destructor();
toolbar.destructor();
};
}, []);

return <div className="component_container">
<div ref={toolbar_container}></div>
<div ref={kanban_container} className="widget"></div>
</div>
}

Alternativ können Sie Daten nach dem Erstellen der Instanz mit setConfig() oder parse() innerhalb von useEffect() laden:

Kanban.jsx
import { useEffect, useRef } from "react";
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export default function KanbanComponent(props) {
let kanban_container = useRef();
let toolbar_container = useRef();

let columns = props.columns;
let cards = props.cards;
let rows = props.rows;

useEffect(() => {
const kanban = new Kanban(kanban_container.current, {
columns: [],
cards: [],
rows: [],
rowKey: "type",
// weitere Konfigurationseigenschaften
});

const toolbar = new Toolbar(toolbar_container.current, {
api: kanban.api,
// weitere Konfigurationseigenschaften
});

kanban.setConfig({ columns, cards, rows });
// oder kanban.parse({ columns, cards, rows });

return () => {
kanban.destructor();
toolbar.destructor();
};
}, []);

return <div className="component_container">
<div ref={toolbar_container}></div>
<div ref={kanban_container} className="widget"></div>
</div>
}

Die Kanban-Komponente ist nun einsatzbereit. Wenn das Element gerendert wird, initialisiert sich Kanban mit den Daten. Die vollständige Liste der unterstützten Konfigurationseigenschaften finden Sie in der Kanban API-Referenz.

Ereignisse behandeln

Benutzeraktionen in Kanban lösen Ereignisse aus. Lauschen Sie auf Ereignisse, um auf bestimmte Aktionen zu reagieren. Die vollständige Liste finden Sie in der Kanban Ereignisreferenz.

Öffnen Sie Kanban.jsx und erweitern Sie den useEffect()-Aufruf:

Kanban.jsx
// ...
useEffect(() => {
const kanban = new Kanban(kanban_container.current, {});

kanban.api.on("add-card", (obj) => {
console.log(obj.columnId);
});

return () => {
kanban.destructor();
};
}, []);
// ...

Starten Sie die App, um das befüllte Kanban-Board auf der Seite anzuzeigen.

DHTMLX Kanban-Board, das in einer React-Anwendung initialisiert wurde, mit gefüllten Spalten und Karten

Das vollständige Projekt finden Sie auf GitHub.

Zum Hauptinhalt springen

Integration mit Svelte

Tipp

Diese Anleitung setzt Kenntnisse der Svelte-Konzepte und -Muster voraus. Zur Einführung siehe die Svelte documentation.

DHTMLX Kanban ist mit Svelte kompatibel. Das vollständige Codebeispiel ist auf GitHub verfügbar.

Projekt erstellen

Info

Installieren Sie Vite (optional) und Node.js, bevor Sie das Projekt erstellen.

Richten Sie ein Svelte-Projekt auf eine der folgenden Arten ein:

  • mit SvelteKit — empfohlen
  • mit Svelte und Vite (ohne SvelteKit) — führen Sie aus:
npm create vite@latest

Weitere Details finden Sie in der Svelte documentation.

Abhängigkeiten installieren

Nennen Sie das Projekt my-svelte-kanban-app. Wechseln Sie in das App-Verzeichnis:

cd my-svelte-kanban-app

Installieren Sie die Abhängigkeiten und starten Sie den Entwicklungsserver mit einem der folgenden Paketmanager:

yarn
yarn start
npm install
npm run dev

Die App läuft unter einer localhost-Adresse (zum Beispiel http://localhost:3000).

Kanban erstellen

Stoppen Sie den Entwicklungsserver und installieren Sie das Kanban-Paket.

Schritt 1. Paket installieren

Laden Sie das trial Kanban package herunter und folgen Sie den im README aufgeführten Schritten. Die Testversion ist 30 Tage lang verfügbar.

Schritt 2. Komponente erstellen

Erstellen Sie eine Svelte-Komponente, die Kanban und die Toolbar einbindet. Fügen Sie eine neue Datei Kanban.svelte im Verzeichnis src/ hinzu.

Quelldateien importieren

Öffnen Sie Kanban.svelte und importieren Sie die Kanban-Quelldateien. Die Importpfade hängen von der Paketversion ab:

  • Für die PRO-Version, die aus einem lokalen Ordner installiert wird:
Kanban.svelte
<script>
import { Kanban, Toolbar } from 'dhx-kanban-package';
import 'dhx-kanban-package/dist/kanban.css';
</script>

Wenn das Paket minifizierte Quelldateien enthält, importieren Sie die CSS-Datei als kanban.min.css.

  • Für die Testversion:
Kanban.svelte
<script>
import { Kanban, Toolbar } from '@dhx/trial-kanban';
import '@dhx/trial-kanban/dist/kanban.css';
</script>

In diesem Tutorial wird die Testversion von Kanban verwendet.

Container einrichten und Kanban initialisieren

Um Kanban mit der Toolbar anzuzeigen, erstellen Sie zwei Container und rufen Sie die Konstruktoren auf. Der folgende Code-Ausschnitt bindet die Container und instanziiert die Komponenten innerhalb von onMount():

Kanban.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Kanban, Toolbar } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

let toolbar_container, kanban_container; // Container für Kanban und Toolbar initialisieren
let kanban, toolbar;

onMount(() => {
// Kanban-Komponente initialisieren
kanban = new Kanban(kanban_container, {})

// Toolbar-Komponente initialisieren
toolbar = new Toolbar(toolbar_container, {
api: kanban.api, // interne Kanban-API bereitstellen
// weitere Konfigurationseigenschaften
})
});

onDestroy(() => {
kanban.destructor(); // Kanban zerstören
toolbar.destructor(); // Toolbar zerstören
});
</script>

<div class="component_container">
<div bind:this={toolbar_container}></div>
<div bind:this={kanban_container} style="height: calc(100% - 56px);"></div>
</div>

Daten laden

Um Kanban mit Daten zu befüllen, stellen Sie einen Datensatz bereit. Erstellen Sie die Datei data.js im Verzeichnis src/:

data.js
export function getData() {
const columns = [
{
label: "Backlog",
id: "backlog"
},
{
label: "In progress",
id: "inprogress"
},
// ...
];

const cards = [
{
id: 1,
label: "Integration with Angular/React",
priority: 1,
color: "#65D3B3",
start_date: new Date("01/07/2021"),
users: [3, 2],
column: "backlog",
type: "feature",
},
{
label: "Archive the cards/boards",
priority: 3,
color: "#58C3FE",
users: [4],
progress: 1,
column: "backlog",
type: "feature",
},
// ...
];

const rows = [
{
label: "Feature",
id: "feature",
},
{
label: "Task",
id: "task",
}
];

return { columns, cards, rows };
}

Öffnen Sie App.svelte, importieren Sie den Datensatz und übergeben Sie die Werte als props an die neue <Kanban/>-Komponente:

App.svelte
<script>
import Kanban from "./Kanban.svelte";
import { getData } from "./data.js";

const { cards, columns, rows } = getData();
</script>

<Kanban {cards} {columns} {rows} />

Öffnen Sie Kanban.svelte und wenden Sie die props auf das Kanban-Konfigurationsobjekt an:

Kanban.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Kanban, Toolbar, defaultEditorShape } from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export let columns;
export let cards;
export let rows;

let toolbar_container, kanban_container;
let kanban, toolbar;

onMount(() => {
kanban = new Kanban(kanban_container, {
columns,
cards,
rows,
rowKey: "type",
// weitere Konfigurationseigenschaften
})

toolbar = new Toolbar(toolbar_container, {
api: kanban.api, // interne Kanban-API bereitstellen
// weitere Konfigurationseigenschaften
})
});

onDestroy(() => {
kanban.destructor();
toolbar.destructor();
});
</script>

<div class="component_container">
<div bind:this={toolbar_container}></div>
<div bind:this={kanban_container} style="height: calc(100% - 56px);"></div>
</div>

Alternativ können Sie Daten nach der Erstellung der Instanz mit setConfig() oder parse() innerhalb von onMount() laden:

Kanban.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Kanban, Toolbar} from "@dhx/trial-kanban";
import "@dhx/trial-kanban/dist/kanban.css";

export let columns;
export let cards;
export let rows;

let toolbar_container, kanban_container;
let kanban, toolbar;

onMount(() => {
kanban = new Kanban(kanban_container, {
columns: [],
cards: [],
rows: [],
rowKey: "type",
// weitere Konfigurationseigenschaften
})

toolbar = new Toolbar(toolbar_container, {
api: kanban.api, // interne Kanban-API bereitstellen
// weitere Konfigurationseigenschaften
})

kanban.setConfig({ columns, cards, rows });
// oder kanban.parse({ columns, cards, rows });
});

onDestroy(() => {
kanban.destructor();
toolbar.destructor();
});
</script>

<div class="component_container">
<div bind:this={toolbar_container}></div>
<div bind:this={kanban_container} style="height: calc(100% - 56px);"></div>
</div>

Die Kanban-Komponente ist nun einsatzbereit. Sobald das Element gerendert wird, initialisiert Kanban sich mit den Daten. Die vollständige Liste der unterstützten Konfigurationseigenschaften finden Sie in der Kanban API-Referenz.

Ereignisse verarbeiten

Benutzeraktionen in Kanban lösen Ereignisse aus. Hören Sie auf Ereignisse, um auf bestimmte Aktionen zu reagieren. Die vollständige Liste finden Sie in der Kanban-Ereignisreferenz.

Öffnen Sie Kanban.svelte und erweitern Sie den onMount()-Callback:

Kanban.svelte
<script>
// ...
let kanban;

onMount(() => {
kanban = new Kanban(kanban_container, {})

kanban.api.on("add-card", (obj) => {
console.log(obj.columnId);
});
});

onDestroy(() => {
kanban.destructor();
});
</script>

// ...

Schritt 3. Kanban zur App hinzufügen

Um die Komponente zu registrieren, öffnen Sie App.svelte und ersetzen Sie den Standardcode:

App.svelte
<script>
import Kanban from "./Kanban.svelte";
import { getData } from "./data.js";

const { columns, cards, rows } = getData();
</script>

<Kanban {cards} {columns} {rows} />

Starten Sie die App, um das befüllte Kanban-Board auf der Seite anzuzeigen.

DHTMLX Kanban-Board, das in einer Svelte-Anwendung initialisiert wurde, mit gefüllten Spalten und Karten

Das vollständige Projekt finden Sie auf GitHub.